"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createStore = void 0;
function overrideMethod(target, methodName, from, newMethodBuilder) {
    var temp0 = "original__".concat(methodName, "__").concat(from, "__is_overriden");
    if (target[temp0] === true) {
        return; // Do not override twice;
    }
    var temp = "original__".concat(methodName, "__").concat(from);
    if (!target[temp] && typeof target[methodName] === 'function') {
        target[temp] = target[methodName].bind(target);
        target[temp].bind(target);
    }
    var alreadyAttached = target[temp];
    if (alreadyAttached) {
        var altered = newMethodBuilder(alreadyAttached);
        var bind = altered.bind(target);
        target[methodName] = bind;
    }
    else {
        var altered = newMethodBuilder(null);
        var bind = altered.bind(target);
        target[methodName] = bind;
    }
    target[temp0] = true;
}
function generateId() {
    var base;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                base = 0;
                _a.label = 1;
            case 1:
                if (!true) return [3 /*break*/, 3];
                base += 1;
                return [4 /*yield*/, base];
            case 2:
                _a.sent();
                return [3 /*break*/, 1];
            case 3: return [2 /*return*/];
        }
    });
}
/**
 * Note: Stencil js has an async `forceUpdate` that batches the rendering.
 *       It is safe to use this class with 'list' and 'plain' in a Stencil context;
 */
var RenderQ = /** @class */ (function () {
    function RenderQ(structure, method, forceUpdate) {
        this.list = [];
        this.set = new Set();
        this.structure = structure;
        this.method = method;
        this.forceUpdate = forceUpdate;
    }
    RenderQ.prototype.add = function (component) {
        if (this.structure === 'list') {
            this.list.push(component);
        }
        else {
            this.set.add(component);
        }
    };
    RenderQ.prototype.values = function () {
        if (this.structure === 'list') {
            return this.list;
        }
        else {
            return this.set.values();
        }
    };
    RenderQ.prototype.clear = function () {
        if (this.structure === 'list') {
            this.list = [];
        }
        else {
            this.set.clear();
        }
    };
    RenderQ.prototype.signalToRender = function () {
        var values = this.values();
        if (this.method === 'plain') {
            this.signalToRenderPlain(values);
        }
        else {
            this.signalToRenderAsync(values);
        }
        this.clear();
    };
    RenderQ.prototype.signalToRenderPlain = function (values) {
        for (var _i = 0, values_1 = values; _i < values_1.length; _i++) {
            var qi = values_1[_i];
            this.forceUpdate(qi);
        }
    };
    RenderQ.prototype.signalToRenderAsync = function (values) {
        var _this = this;
        var vs = __spreadArray([], values, true);
        new Promise(function () {
            _this.signalToRenderPlain(vs);
        });
    };
    return RenderQ;
}());
var wholestashidGenerator = generateId();
function createStore(initialState, rootReducer, config) {
    var forceUpdate = config.forceUpdate, getElement = config.getElement, getRenderingRef = config.getRenderingRef;
    var wholestashid = wholestashidGenerator.next().value;
    var actionEventType = "stash-action-".concat(wholestashid);
    var subs = [];
    var stash = __assign({}, initialState);
    var reducer = rootReducer;
    var getState = function () { return stash; };
    var renderQ = new RenderQ('set', 'async', forceUpdate);
    var handleActionEvent = function (evt) {
        var crtStash = stash;
        var newStash = reducer(crtStash, evt.detail);
        subs = subs.filter(function (sub) { return sub.caller2.isConnected; });
        for (var _i = 0, subs_1 = subs; _i < subs_1.length; _i++) {
            var sc = subs_1[_i];
            var newSelection = sc.sel2(newStash, sc.vars2);
            var oldSelection = sc.sel2(crtStash, sc.vars2);
            if (newSelection !== oldSelection) {
                renderQ.add(sc.caller2);
            }
        }
        stash = newStash;
        // @ts-ignore
        window.stash = stash;
        renderQ.signalToRender();
    };
    var handleAction = function (action) {
        var crtStash = stash;
        var newStash = reducer(crtStash, action);
        subs = subs.filter(function (sub) { return sub.caller2.isConnected; });
        for (var _i = 0, subs_2 = subs; _i < subs_2.length; _i++) {
            var sc = subs_2[_i];
            var newSelection = sc.sel2(newStash, sc.vars2);
            var oldSelection = sc.sel2(crtStash, sc.vars2);
            if (newSelection !== oldSelection) {
                renderQ.add(sc.caller2);
            }
        }
        stash = newStash;
        // @ts-ignore
        window.stash = stash;
        renderQ.signalToRender();
    };
    var eventListener = function (evt) {
        try {
            evt.stopPropagation();
            evt.preventDefault();
            handleActionEvent(evt);
        }
        catch (err) {
            var newErr = new Error('Stash event listener: ' + (err === null || err === void 0 ? void 0 : err.message));
            if (err.stack) {
                newErr.stack = err.stack;
            }
            throw newErr;
        }
    };
    function atachStashActionEvent(_onEvent, el) {
        var options = {
            capture: true,
        };
        // This will be added any time the this file is modified during development in watch files mode
        // @ts-ignore
        el.addEventListener(actionEventType, eventListener, options);
        return function () {
            // @ts-ignore
            el.removeEventListener(actionEventType, eventListener, options);
        };
    }
    function createProvider(component) {
        // @ts-ignore
        var stash = rootReducer(initialState, { type: '__STASH_INIT__' });
        var element = getElement(component);
        var detach = atachStashActionEvent(function () { }, element);
        overrideMethod(component, 'disconnectedCallback', 'createProvider', function (original) {
            return function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                detach();
                original === null || original === void 0 ? void 0 : original.apply(void 0, args);
            };
        });
    }
    function createDispatch(component) {
        // const el = getElement(component);
        if (!component['onCleanups']) {
            var onCleaups = [];
            component['onCleanups'] = onCleaups;
        }
        var dispatch = function dispatch(action) {
            var detail = { type: action.type, payload: action.payload };
            var ce = new CustomEvent(actionEventType, {
                detail: detail,
                bubbles: true,
                cancelable: true,
                composed: true,
            });
            // el.dispatchEvent(ce);
            handleAction(action);
            return ce;
        };
        var thunkDispatch = function thunkDispatch(action) {
            var thunkOnCleanup = undefined;
            var context = {
                setOnCleanup: function (onCleaup) {
                    thunkOnCleanup = onCleaup;
                    component['onCleanups'].push(onCleaup);
                },
            };
            if (action[Symbol.toStringTag] === 'AsyncFunction') {
                // it is an async thunk
                action(dispatch, getState, context).then(function (r) {
                    component['onCleanups'] = component['onCleanups'].filter(function (oc) { return oc !== thunkOnCleanup; });
                    return r;
                });
            }
            else if (Object.prototype.toString.call(action) === '[object Function]') {
                // it is a thunk
                action(dispatch, getState, context);
                component['onCleanups'] = component['onCleanups'].filter(function (oc) { return oc !== thunkOnCleanup; });
            }
            else {
                // @ts-ignore
                dispatch(action);
            }
        };
        overrideMethod(component, 'disconnectedCallback', 'createDispatch', function (original) {
            return function () {
                for (var _i = 0, _a = component['onCleanups']; _i < _a.length; _i++) {
                    var onCleanup = _a[_i];
                    onCleanup === null || onCleanup === void 0 ? void 0 : onCleanup();
                }
                original === null || original === void 0 ? void 0 : original();
            };
        });
        return thunkDispatch;
    } // createDispatch
    var componentIdGenerator = generateId();
    function createSelector(selector, component) {
        var el = getElement(component);
        var componentName = component.constructor.name;
        if (!component['ownsubs']) {
            // component['ownsubs'] = new Set<SEV<S, any, any>>();
            component['ownsubs'] = new Set();
        }
        if (!el['componentId']) {
            var id = componentIdGenerator.next().value;
            el['componentId'] = "".concat(componentName, "::").concat(id);
        }
        if (!component['idGenerator']) {
            var idGenerator_1 = generateId();
            component['idGenerator'] = idGenerator_1;
        }
        var idGenerator = component['idGenerator'];
        var selId = idGenerator.next().value;
        var componentId = el['componentId'];
        selector['stashId'] = "".concat(componentId, "::").concat(selId);
        var select = function select() {
            var rref = getRenderingRef();
            var existingSub = subs.find(function (sb) { return sb.sel2['stashId'] === selector['stashId']; });
            // register only if it's called from render
            if (!existingSub && rref) {
                var sub = { sel2: selector, caller2: el, vars2: undefined };
                subs.push(sub);
                component['ownsubs'].add(selector['stashId']);
            }
            var v = selector(stash);
            return v;
        };
        overrideMethod(component, 'disconnectedCallback', 'createSelector', function (original) {
            return function () {
                // subs = subs.filter(sb => sb.sel2['stashId'] === selector['stashId'] && sb.);
                // remove all own subs from main subs
                subs = subs.filter(function (sb) { return !component['ownsubs'].has(sb.sel2['stashId']); });
                delete component['ownsubs'];
                original === null || original === void 0 ? void 0 : original();
            };
        });
        function selectorFunc() {
            return select();
        }
        selectorFunc.bind(component);
        return selectorFunc;
    }
    return { createDispatch: createDispatch, createSelector: createSelector, createProvider: createProvider };
}
exports.createStore = createStore;
